﻿bass := A_ScriptDir . "\x64\bass.dll"
if !hLib := DllCall("LoadLibrary", "Str", bass, "Ptr")
   throw "Failed to load bass.dll"
DllCall(bass . "\BASS_Init", "Int", -1, "UInt", 44100, "UInt", 0, "Ptr", A_ScriptHwnd, "Ptr", 0)

flags := (BASS_SAMPLE_LOOP := 4) | (BASS_SAMPLE_OVER_POS := 0x20000)
; https://pages.mtu.edu/~suits/notefreqs.html
for k, v in [440.00, 554.37, 659.26] ; A, C-sharp, E
   hSample%k% := DllCall(bass . "\BASS_SampleCreate", "UInt", 256, "UInt", v*64, "UInt", 1, "UInt", 1, "UInt", flags, "Ptr")

VarSetCapacity(buff, 256, 0)
Loop 128
   NumPut(32767.0 * sin((A_Index - 1)*6.283185/64), buff, (A_Index - 1)*2, "UShort")

Loop 3
   DllCall(bass . "\BASS_SampleSetData", "Ptr", hSample%A_Index%, "Ptr", &buff)

Loop 3 {
   hChannal%A_Index% := DllCall(bass . "\BASS_SampleGetChannel", "Ptr", hSample%A_Index%, "UInt", false, "Ptr")
   DllCall(bass . "\BASS_ChannelPlay", "Ptr", hChannal%A_Index%, "UInt", true)
}

Sleep 1500

Loop 3
   DllCall(bass . "\BASS_ChannelPause", "Ptr", hChannal%A_Index%)
Sleep, 100
Loop 3
   DllCall(bass . "\BASS_ChannelStop", "Ptr", hChannal%A_Index%)

Loop 3
   DllCall(bass . "\BASS_SampleFree", "Ptr", hSample%A_Index%)
DllCall("FreeLibrary", "Ptr", hLib)